function Create(self)
	local closest = 100000
	local closestX = 0
	local closestY = 0
	if DeepTunnelList ~= nil then
	
		local i = #DeepTunnelList
		
		while i >= 0 do
			local posX;
			if DeepTunnelList[i] ~= nil and DeepTunnelList[i].Team == self.Team then
				posX = DeepTunnelList[i].Pos.X
				if posX-self.Pos.X > SceneMan.SceneWidth/2 then
					posX = posX - SceneMan.SceneWidth;
				elseif posX+self.Pos.X < SceneMan.SceneWidth/2 then
					posX = posX + SceneMan.SceneWidth;
				end
				
				if math.abs(posX-self.Pos.X) < closest then
					closest = posX-self.Pos.X
					closestX = DeepTunnelList[i].Pos.X
					closestY = DeepTunnelList[i].Pos.Y
				end				
				
			end
			
			i = i - 1
		end

		if closest ~= 100000 then
			self.Pos = Vector(closestX , closestY)
			local fxa = CreateMOSRotating("Deep Tunnel Particle", "Loyalists.rte");
			fxa.Pos = self.Pos
			MovableMan:AddParticle(fxa);
			local Activ = ActivityMan:GetActivity()
			Activ:ReportDeath(self.Team, -1)
			self:GibThis()
		else
			self.Vel.Y = -20
			self.Pos.Y = -50
		end

	else
		self.Vel.Y = -20
		self.Pos.Y = -50
	end
end