function Create(self)

	self.animType = {}

	local i;

	attackStage = {}

	---------- Normal Idle ----------------
	self.normalStance = Vector(3,5)
	self.normalSupport = Vector(3,3)
	self.normalAngle = 0
	self.normalSpeed = 4
	
	---------- Bayonet Idle ----------------
	self.bayonetStance = Vector(3,5)
	self.bayonetSupport = Vector(3,3)
	self.bayonetAngle = 0.35
	self.bayonetSpeed = 4

	--------------------------------------------
	------------- Normal Attack 1 --------------
	
	local attackStage
	i = 0
	
	attackStage = {}
	
	------------- Preparing Attack -------------
	
	i = i + 1
	attackStage[i] = {}
	attackStage[i].stance = Vector(-4,6)
	attackStage[i].support = Vector(3,3)
	
	attackStage[i].angle = 0.1
	attackStage[i].angleSpeed = 3

	attackStage[i].canAttack = false

	attackStage[i].duration = 300
	
	-------------- Launching Attack ---------------
	i = i + 1
	attackStage[i] = {}
	attackStage[i].stance = Vector(9,3)
	attackStage[i].support = Vector(1,3)

	attackStage[i].angle = 0
	attackStage[i].angleSpeed = 4
	
	attackStage[i].canAttack = false

	attackStage[i].duration = 25

	i = i + 1
	attackStage[i] = {}
	attackStage[i].stance = Vector(9,3)
	attackStage[i].support = Vector(1,3)

	attackStage[i].angle = 0
	attackStage[i].angleSpeed = 2
	
	attackStage[i].canAttack = true

	attackStage[i].duration = 125

	----------------- Recovery ----------------
	i = i + 1
	attackStage[i] = {}
	attackStage[i].stance = Vector(5,4)
	attackStage[i].support = Vector(1,3)

	attackStage[i].angle = 0.2
	attackStage[i].angleSpeed = 4
	
	attackStage[i].canAttack = false

	attackStage[i].duration = 80

	---------------- Normal Delay -------------
	i = i + 1
	attackStage[i] = {}
	attackStage[i].stance = self.bayonetStance
	attackStage[i].support = self.bayonetSupport

	attackStage[i].angle = self.bayonetAngle
	attackStage[i].angleSpeed = self.bayonetSpeed
	
	attackStage[i].canAttack = false

	attackStage[i].duration = 250

	self.animType[1] = attackStage

	--------------------------------------------------------------------
	------------------------End Attack animations-----------------------
	--------------------------------------------------------------------

	--------------------------------------------------------------------
	----------------------- Afix Bayonet (BM) -------------------------------

	local afixBayonetSwitch
	i = 0

	afixBayonetSwitch = {}

	------------- Enabling bayonet -------------

	i = i + 1
	afixBayonetSwitch[i] = {}
	afixBayonetSwitch[i].stance = Vector(-2,3)
	afixBayonetSwitch[i].support = Vector(9,0)
	
	afixBayonetSwitch[i].angle = 0.45
	afixBayonetSwitch[i].angleSpeed = 3

	afixBayonetSwitch[i].canAttack = false

	afixBayonetSwitch[i].duration = 320
	
	------------- Returning to normal -------------

	i = i + 1
	afixBayonetSwitch[i] = {}
	afixBayonetSwitch[i].stance = self.bayonetStance
	afixBayonetSwitch[i].support = self.bayonetSupport

	afixBayonetSwitch[i].angle = self.bayonetAngle
	afixBayonetSwitch[i].angleSpeed = 1

	afixBayonetSwitch[i].canAttack = false
	
	afixBayonetSwitch[i].afixBayonet = true;			--Will also detach to simplify
	afixBayonetSwitch[i].switchMode = true;				--Actual bayonet mode

	afixBayonetSwitch[i].duration = 200


	self.animType[2] = afixBayonetSwitch
	
	--------------------------------------------------------------------
	----------------------- Afix Bayonet (NM) -------------------------------

	local afixBayonet
	i = 0

	afixBayonet = {}

	------------- Enabling bayonet -------------

	i = i + 1
	afixBayonet[i] = {}
	afixBayonet[i].stance = Vector(-2,3)
	afixBayonet[i].support = Vector(9,0)
	
	afixBayonet[i].angle = 0.45
	afixBayonet[i].angleSpeed = 3

	afixBayonet[i].canAttack = false

	afixBayonet[i].duration = 320
	
	------------- Returning to normal -------------

	i = i + 1
	afixBayonet[i] = {}
	afixBayonet[i].stance = self.normalStance
	afixBayonet[i].support = self.normalSupport

	afixBayonet[i].angle = self.normalAngle
	afixBayonet[i].angleSpeed = 3

	afixBayonet[i].canAttack = false
	
	afixBayonet[i].afixBayonet = true;			--Will also detach to simplify
	afixBayonet[i].switchMode = false;				--Actual bayonet mode

	afixBayonet[i].duration = 200


	self.animType[3] = afixBayonet
	
	------------------------------------------------------------------
	----------------------- Remove Bayonet -------------------------------

	local removeBayonet
	i = 0

	removeBayonet = {}

	------------- Disabling bayonet -------------

	i = i + 1
	removeBayonet[i] = {}
	removeBayonet[i].stance = Vector(-2,3)
	removeBayonet[i].support = Vector(9,0)
	
	removeBayonet[i].angle = 0.45
	removeBayonet[i].angleSpeed = 3

	removeBayonet[i].canAttack = false

	removeBayonet[i].duration = 320
	
	------------- Returning to normal -------------

	i = i + 1
	removeBayonet[i] = {}
	removeBayonet[i].stance = self.normalStance
	removeBayonet[i].support = self.normalSupport

	removeBayonet[i].angle = self.normalAngle
	removeBayonet[i].angleSpeed = 4

	removeBayonet[i].canAttack = false
	
	removeBayonet[i].afixBayonet = true;			--Will also detach to simplify
	removeBayonet[i].switchMode = true;				--Actual bayonet mode

	removeBayonet[i].duration = 200


	self.animType[4] = removeBayonet


	----------------------------------------------------------------------
	-------------------- Switch to Bayonet mode --------------------------

	local switchBayonet
	i = 0

	switchBayonet = {}

	------------- Switch to bayonet mode -------------

	i = i + 1
	switchBayonet[i] = {}
	switchBayonet[i].stance = self.bayonetStance
	switchBayonet[i].support = self.bayonetSupport

	switchBayonet[i].angle = self.bayonetAngle
	switchBayonet[i].angleSpeed = 3
	
	switchBayonet[i].afixBayonet = false;			--Will also detach to simplify
	switchBayonet[i].switchMode = true;				--Actual bayonet mode

	switchBayonet[i].duration = 180


	self.animType[5] = switchBayonet

	----------------------------------------------------------------------
	-------------------- Switch to Normal mode ---------------------------

	local switchNormal
	i = 0

	switchNormal = {}

	------------- Switch to Normal mode -------------

	i = i + 1
	switchNormal[i] = {}
	switchNormal[i].stance = self.normalStance
	switchNormal[i].support = self.normalSupport

	switchNormal[i].angle = self.normalAngle
	switchNormal[i].angleSpeed = 3
	
	switchNormal[i].afixBayonet = false;			--Will also detach to simplify
	switchNormal[i].switchMode = true;				--Actual bayonet mode

	switchNormal[i].duration = 180


	self.animType[6] = switchNormal

	----------------- Other Values ---------------

	self.whatStage = 0
	self.whatAnimType = 0

	self.animationTimer = Timer();
	self.isAnimating = false
	self.isAnimatingSet = false;

	self.angleNum = 0
	self.origAngleNum = self.normalAngle
	
	self.modifiedAngle = self.normalAngle
	self.modifiedSpeed = self.normalSpeed
	
	self.spawnAttack = true
	self.canAttack = false;
	
	self.afixBayonet = false;
	self.switchMode = false

	self.parent = nil

	self.bayonetAttachable = "Loyalist Standard Rifle Bayonet"
	self.bayonet = CreateAttachable(self.bayonetAttachable)

	if math.random() > 0.65 then		--Attach bayonet != bayonet mode
		self.attachedBayonet = true
		self:AddAttachable(self.bayonet, Vector(0,0))
	else
		self.attachedBayonet = false
	end

	self.bayonetMode = false;			--Bayonet mode requires attached bayonet

end

function Update(self)

	if self:IsAttached() == true then 		--I think this is more performance friendly as it doesn't check the parent every frame, rather just when the gun is first taken.
		if self.parent == nil then
			if IsAHuman(self:GetRootParent()) then
				self.parent = ToAHuman(self:GetRootParent())
			end
		end
	else
		self.parent = nil;
	end
	
	if self.bayonetMode == true then
		self:Deactivate()
		self.Reloadable = false
	else
		self.Reloadable = true
	end
	
	if self.parent then 

		if self.origAngleNum > self.modifiedAngle then
			if self.angleNum > self.modifiedAngle then
				self.angleNum = self.angleNum -1*0.01*self.modifiedSpeed;
			else
				self.angleNum = self.modifiedAngle
			end
		elseif self.origAngleNum < self.modifiedAngle then
			if self.angleNum < self.modifiedAngle then
				self.angleNum = self.angleNum +1*0.01*self.modifiedSpeed;
			else
				self.angleNum = self.modifiedAngle
			end
		else
			self.angleNum = self.modifiedAngle
		end

		if self.parent:IsPlayerControlled() and self.parent.Status == Actor.STABLE 
			and self.parent.BGArm and not self:IsReloading() and not self.isAnimating then
			if UInputMan:KeyPressed(2) or UInputMan:KeyPressed(22) then
				self.isAnimatingSet = true
				
				if UInputMan:KeyPressed(2) then --- B: Attach bayonet
					if self.attachedBayonet == false then				
						self.whatAnimType = 3
					else
						self.whatAnimType = 4
					end
				elseif UInputMan:KeyPressed(22) then		--V: Switch modes, attach bayonet if unattached
					if self.attachedBayonet == false then
						self.whatAnimType = 2
					else
						if self.bayonetMode == false then
							self.whatAnimType = 5
						else
							self.whatAnimType = 6
						end
					end
				end
			
				self.parent:GetController():SetState(Controller.AIM_SHARP,false);
			end
		end
	
		if self.bayonetMode == true then
			self.parent:GetController():SetState(Controller.AIM_SHARP,false);

			if self.parent:GetController():IsState(Controller.WEAPON_FIRE) and self.isAnimating == false then
				self.isAnimatingSet = true
				self.whatAnimType = 1
			end
		end

		if self.isAnimatingSet == true then
			self.isAnimating = true;
			self.whatStage = 1
			self.animationTimer:Reset()			
			self.isAnimatingSet = false

			self.spawnAttack = true
			self.afixBayonet = true
			self.switchMode = true;
		end
		
		if self.isAnimating == true then

			local attackStages = self.animType[self.whatAnimType]
			local currentStage = attackStages[self.whatStage]

			self.StanceOffset = currentStage.stance
			self.SupportOffset = currentStage.support
			self.modifiedAngle = currentStage.angle
			self.modifiedSpeed = currentStage.angleSpeed

			self.canAttack = currentStage.canAttack
			
			if self.afixBayonet == true and currentStage.afixBayonet == true then			--First check if we are afixing/not the bayonet, and check if we change modes too
				if self.attachedBayonet == false then
					self.attachedBayonet = true					
					self.bayonet = CreateAttachable(self.bayonetAttachable)
					self:AddAttachable(self.bayonet, Vector(0,0))

				elseif self.attachedBayonet == true then
					self.attachedBayonet = false
					self:RemoveAttachable(self.bayonet, false, false)

				end
				self.afixBayonet = false;
			end
			
			if self.switchMode == true and currentStage.switchMode == true then				--If we aint moving the bayonet, simply check if we are changing modes directly
			
				if self.attachedBayonet == true then
					if self.bayonetMode == true then
						self.bayonetMode = false
						self:AddToGroup("Weapons - Primary")
						self:AddToGroup("Weapons - Light")
						self:RemoveFromGroup("Weapons - Melee")
					elseif self.bayonetMode == false then
						self.bayonetMode = true
						self:RemoveFromGroup("Weapons - Primary")
						self:RemoveFromGroup("Weapons - Light")
						self:AddToGroup("Weapons - Melee")
					end
				else
					self.bayonetMode = false
					self:AddToGroup("Weapons - Primary")
					self:AddToGroup("Weapons - Light")
					self:RemoveFromGroup("Weapons - Melee")
				end
				
				self.switchMode = false
			end
			
			if self.spawnAttack == true and self.canAttack == true then

				local weaponPos = self.Pos + Vector((30*self.FlipFactor), 3):RadRotate(self.RotAngle)
				local weaponCheck = Vector((36*self.FlipFactor), 0):RadRotate(self.RotAngle)
							
--				PrimitiveMan:DrawLinePrimitive(self.Team, weaponPos, self.Pos + weaponCheck, 13);
			
				local moCheck = SceneMan:CastMORay(weaponPos, weaponCheck, rte.NoMOID, self.Team, rte.airID, true, 1);
				if moCheck and moCheck ~= rte.NoMOID then
					local mo = MovableMan:GetMOFromID(moCheck);
--					AudioMan:PlaySound("Ronin.rte/Devices/Tools/Shovel/Sounds/Melee".. math.random(3) ..".flac", self.MuzzlePos);

					for i = 0, 3 do
						local part = CreateMOPixel("Bayonet Strike", "Loyalists.rte");
						part.Pos = self.Pos + Vector(((20+i*2)*self.FlipFactor), 2):RadRotate(self.RotAngle)
						part.Vel = self.Vel + Vector(15*self.FlipFactor, 0):RadRotate(self.RotAngle)
						part.Team = self.parent.Team;	part.IgnoresTeamHits = true;
						MovableMan:AddParticle(part);
					end
					
					for i = 0, 3 do
						local part = CreateMOPixel("Bayonet Strike", "Loyalists.rte");
						part.Pos = self.Pos + Vector(((20+i*2)*self.FlipFactor), 1):RadRotate(self.RotAngle)
						part.Vel = self.Vel + Vector(15*self.FlipFactor, 0):RadRotate(self.RotAngle)
						part.Team = self.parent.Team;	part.IgnoresTeamHits = true;
						MovableMan:AddParticle(part);
					end

					if IsActor(mo:GetRootParent()) then
						local actor = ToActor(mo:GetRootParent());
	--[[
						local damage = math.random(10,25)		--Make it class dependant
						actor.Health = actor.Health - damage						
						local disarm = math.random()			--Same as above
						if disarm > 0.75 then
							actor:GetController():SetState(Controller.WEAPON_DROP,true)
						end
	--]]
					end
					self.spawnAttack = false;
				end
			end

			if self.animationTimer:IsPastSimMS(currentStage.duration) then
				self.spawnAttack = true
				self.afixBayonet = true;
				self.switchMode = true;
				
				self.origAngleNum = self.angleNum
				
				self.animationTimer:Reset();
				
				if self.whatStage < #attackStages then
					self.whatStage = self.whatStage + 1
				else
					self.isAnimating = false
				end
			end
		end
	end
end