--[[
######################################################################
##  File:	Chute.lua												##
##  Author:	'OliveD' (olived@live.ca)								##
##	Notes:	Slows down the parachute and allows for a small amount	##
##			of scripted control. At some point, I pasted in someone	##
##			else's script to see how it would handle with this craft##
##			It resulted in nothing working and broke the steering.	##
##			Unfortunately, I released it like that. I don't know	##
##			if I left anything that doesn't belong to me in here,	##
##			and I don't remember who's script it was. At any rate,	##
##			should work now.										##
######################################################################
]]--


function Create(self)
	self.dropTimer = Timer();
	self.speedLimit = 5;
	self.rotValue=-.1;
	self.rotMode=0;
end

function Update(self)
	--Brakes
		if self.Vel.Y > self.speedLimit then
			self.Vel.Y = self.speedLimit;
		elseif self.Vel.Y < -self.speedLimit then
			self.Vel.Y = -self.speedLimit;
		end
		if self.Vel.X > self.speedLimit then
			self.Vel.X = self.speedLimit;
		elseif self.Vel.X < -self.speedLimit then
			self.Vel.X = -self.speedLimit;
		end
	--Control
	--Wouldn't want to divide by zero now would ya
	if self.RotAngle == 0 then RotAngle=.001; end
	if self:GetController():IsState(Controller.MOVE_RIGHT) then
		self.Vel.X = self.Vel.X+.2;
		self.RotAngle = self.RotAngle + (.2-math.abs(self.RotAngle))/20;
	elseif self:GetController():IsState(Controller.MOVE_LEFT) then
		self.Vel.X = self.Vel.X - .2;
		self.RotAngle = self.RotAngle - (.2-math.abs(self.RotAngle))/20;
	else
		self.RotAngle = self.RotAngle*.98;
		self.Vel.X = self.Vel.X*.98;
	end
	--Animate slow rotation
	if self.rotMode == 0 then
		self.rotValue = self.rotValue+0.005;
		self.RotAngle = self.RotAngle+0.005;
		if self.rotValue > .1 then self.rotMode = 1 end
	else
		self.rotValue = self.rotValue-0.005;
		self.RotAngle = self.RotAngle-0.005;
		if self.rotValue < -.1 then self.rotMode = 0 end
	end
end

function Destroy(self)
	ActivityMan:GetActivity():ReportDeath(self.Team,-1);
end