function Create (self)

	self.isFlaming = false
	self.matchStruck = false
	
	self.fuzeDelay = (math.random(60,80)*100)
	self.fuzeTimer = Timer()

end

function Update(self)

	if self:IsActivated() then
		self.isFlaming = true
		
		self.GibImpulseLimit = 5
		
		if self.matchStruck == false then
			sfx = CreateAEmitter("Match Strike Sound", "Loyalists.rte");
			sfx.Pos = self.Pos;
			MovableMan:AddParticle(sfx);
			
			self.matchStruck = true
			self.fuzeTimer:Reset()
		end
		
		if self.fuzeTimer:IsPastSimMS(self.fuzeDelay) then
			self:GibThis()
		end
	end
end

function Destroy(self)

	if self.isFlaming == true then
		local Payload = CreateMOSRotating("Petrol Grenade Payload", "Loyalists.rte")
		if Payload then
			Payload.Pos = self.Pos
			MovableMan:AddParticle(Payload)
			Payload:GibThis()
		end
	end
end
